<div class="mb-2" [ngSwitch]="data.type" *ngIf="!!data">
  <ng-container *ngSwitchCase="'location'">
    <bail-form-field [label]="data.label">
      <ng-container *ngIf="!!value; else notProvided">
        <p class="mb-0">{{ value }}</p>
      </ng-container>
    </bail-form-field>

    <bail-map
      [latitude]="data.geocode.geometry.location.lat"
      [longitude]="data.geocode.geometry.location.lng"
      *ngIf="data.geocode"
    ></bail-map>

    <div class="street-view-values row" *ngIf="!!data.street_views?.length">
      <div *ngFor="let streetView of data.street_views" class="col-md-4 mb-3 street-view-value">
        <img [src]="streetView.url" alt="" class="img-thumbnail">

        <div class="text-center text-secondary street-view-caption" *ngIf="streetView.caption">
          {{ streetView.caption }}
        </div>
      </div>
    </div>
  </ng-container>

  <bail-form-field [label]="data.label" *ngSwitchCase="'textarea'">
    <ng-container *ngIf="!!value; else notProvided">
      <div class="mb-0" [innerHTML]="value" *ngIf="value"></div>
    </ng-container>
  </bail-form-field>

  <bail-form-field [label]="data.label" *ngSwitchCase="'plainTextarea'">
    <ng-container *ngIf="!!value; else notProvided">
      <div class="mb-0" [innerHTML]="value" *ngIf="value"></div>
    </ng-container>
  </bail-form-field>

  <bail-form-field [label]="data.label" *ngSwitchCase="'date'">
    <ng-container *ngIf="!!value; else notProvided">
      <p class="mb-0" *ngIf="value">{{ value | userSubmittedDate }}</p>
    </ng-container>
  </bail-form-field>

  <bail-form-field [label]="data.label" *ngSwitchCase="'switch'">
    <span class="badge badge-success" *ngIf="value">Yes</span>
    <span class="badge badge-danger" *ngIf="!value">No</span>
  </bail-form-field>

  <bail-form-field [label]="data.label" *ngSwitchCase="'upload'">
    <table class="table" *ngIf="data.multiple ? !!value?.length : !!value">
      <tbody *ngIf="data.multiple">
        <tr *ngFor="let v of value">
          <td>
            <bail-upload-image-preview [url]="v.web_url || v.thumbnail_url || v.url"></bail-upload-image-preview>
          </td>
          <td>
            {{ v.name }}
          </td>
        </tr>
      </tbody>

      <tbody *ngIf="!data.multiple">
        <tr>
          <td>
            <bail-upload-image-preview [url]="value.web_url || value.thumbnail_url || value.url"></bail-upload-image-preview>
          </td>
          <td>
            {{ value.name }}
          </td>
        </tr>
      </tbody>
    </table>

    <ng-container [ngTemplateOutlet]="notProvided" *ngIf="data.multiple ? !value?.length : !value"></ng-container>
  </bail-form-field>

  <bail-form-field [label]="data.label" *ngSwitchCase="'incidentType'">
    <ng-container *ngIf="!!value; else notProvided">
      <p class="mb-0">
        <ng-container *ngIf="!!data.parent_value && data.parent !== data.key">{{ data.parent_value}} - </ng-container>{{ value }}
      </p>
    </ng-container>
  </bail-form-field>

  <bail-form-field [label]="data.label" *ngSwitchCase="'vehicleType'">
    <ng-container *ngIf="!!value; else notProvided">
      <p class="mb-0">
          {{ value }}<ng-container *ngIf="!!data.other_vehicle_type"> - {{ data.other_vehicle_type}}</ng-container>
      </p>
    </ng-container>
  </bail-form-field>

  <bail-damage-selector-value
    [label]="data.label"
    [section]="value"
    [image]="data.image"
    *ngSwitchCase="'damageSelector'"
  ></bail-damage-selector-value>

  <div
    class="control-helper-text"
    [innerHTML]="data.body | safeHtml"
    *ngSwitchCase="'helperText'"
  ></div>

  <bail-form-field [label]="data.label" *ngSwitchDefault>
    <ng-container *ngIf="!data.multiple; else multipleValues">
      <ng-container *ngIf="!!value && !!data; else notProvided">
        <p class="mb-0">{{ value }}</p>
      </ng-container>
    </ng-container>
  </bail-form-field>

  <ng-template #multipleValues>
    <p class="mb-0" *ngFor="let v of value">
      {{ v.value }}
    </p>
    <p class="mb-0" *ngIf="!value || !value.length">
      <i class="text-muted">Not Provided</i>
    </p>
  </ng-template>
</div>

<ng-template #notProvided>
  <p class="mb-0 no-value">
    <i class="text-muted">Not Provided</i>
  </p>
</ng-template>
